/**
 * SUBMODAL v1.5
 * Used for displaying DHTML only popups instead of using buggy modal windows.
 *
 * By Seth Banks
 * http://www.subimage.com/
 *
 * Contributions by:
 * 	Eric Angel - tab index code
 * 	Scott - hiding/showing selects for IE users
 *	Todd Huss - inserting modal dynamically and anchor classes
 *
 * Up to date code can be found at http://www.subimage.com/dhtml/subModal
 * 
 *
 * This code is free for you to use anywhere, just keep this comment block.
 */

// Popup code


//added calendar

var cal;


//return the calender object if doesnt exist create
function Cal(){
	if(cal != null) return cal;
 	var inputItem;
	if (window.navigator.userAgent.indexOf("MSIE") > -1) 
		inputItem = document.frames["popupFrame"].document.getElementById("time");
	else		
		inputItem = document.getElementById("popupFrame").contentDocument.getElementById("time");
	cal = new calendar1(inputItem);
	return cal;
}

function removeCalendar(){
	cal = null;
}

var gPopupMask = null;
var gPopupContainer = null;
var gPopFrame = null;
var gReturnFunc;
var gPopupIsShown = false;
var gDefaultPage = "modalContent.html";
var gHideSelects = false;
var gReturnVal = null;

var gTabIndexes = new Array();
// Pre-defined list of tags we want to disable/enable tabbing into
var gTabbableTags = new Array("A","BUTTON","TEXTAREA","INPUT","IFRAME");	

// If using Mozilla or Firefox, use Tab-key trap.
if (!document.all) {
	document.onkeypress = keyDownHandler;
}



/**
 * Initializes popup code on load.	
 */
function initPopUp() {
	// Add the HTML to the body
	theBody = document.getElementsByTagName('BODY')[0];
	popmask = document.createElement('div');
	popmask.id = 'popupMask';
	popcont = document.createElement('div');
	popcont.id = 'popupContainer';
	popcont.innerHTML = '' +
		'<div id="popupInner">' +
			'<div id="popupTitleBar">' +
				'<div id="popupTitle"></div>' +
				'<div id="popupControls">' +
					'<img src="images/busy.gif" id="popBusyBox" style="display:none" />' +
					'<img src="close.gif" onclick="hidePopWin(false);" id="popCloseBox" />' +
				'</div>' +
			'</div>' +
			'<iframe src="'+ gDefaultPage +'" style="width:100%;height:100%;background-color:transparent;" scrolling="no" frameborder="0" allowtransparency="true" id="popupFrame" name="popupFrame" width="100%" height="100%"></iframe>' +
		'</div>';
	theBody.appendChild(popmask);
	theBody.appendChild(popcont);
	
	gPopupMask = document.getElementById("popupMask");
	gPopupContainer = document.getElementById("popupContainer");
	gPopFrame = document.getElementById("popupFrame");	
	
	// check to see if this is IE version 6 or lower. hide select boxes if so
	// maybe they'll fix this in version 7?
	var brsVersion = parseInt(window.navigator.appVersion.charAt(0), 10);
	if (brsVersion <= 6 && window.navigator.userAgent.indexOf("MSIE") > -1) {
		gHideSelects = true;
	}
	
	// Add onclick handlers to 'a' elements of class submodal or submodal-width-height
	var elms = document.getElementsByTagName('a');
	for (i = 0; i < elms.length; i++) {
		if (elms[i].className.indexOf("submodal") == 0) { 
			// var onclick = 'function (){showPopWin(\''+elms[i].href+'\','+width+', '+height+', null);return false;};';
			// elms[i].onclick = eval(onclick);
			elms[i].onclick = function(){
				// default width and height
				var width = 400;
				var height = 200;
				// Parse out optional width and height from className
				params = this.className.split('-');
				if (params.length == 3) {
					width = parseInt(params[1]);
					height = parseInt(params[2]);
				}
				showPopWin(this.href,width,height,null); return false;
			}
		}
	}
}
addEvent(window, "load", initPopUp);

 /**
	* @argument width - int in pixels
	* @argument height - int in pixels
	* @argument url - url to display
	* @argument returnFunc - function to call when returning true from the window.
	* @argument showCloseBox - show the close box - default true
	*/

function popFormShowBusy(){
	document.getElementById("popCloseBox").style.display = "none";
	document.getElementById("popBusyBox").style.display = "block";
}

function popFormHideBusy(){
	document.getElementById("popBusyBox").style.display = "none";
}


function getPopDocument(){
	if (window.navigator.userAgent.indexOf("MSIE") > -1){
		return  document.frames["popupFrame"].document;		
	}else{
		return document.getElementById("popupFrame").contentDocument;		
	}
}

function showPopWin(url, width, height, returnFunc, showCloseBox,title,showBusy ) {
	// show or hide the window close widget
	if (showCloseBox) {
		document.getElementById("popCloseBox").style.display = "block";
	} else {
		document.getElementById("popCloseBox").style.display = "none";
	}
	// show or hide the window busy widget
	if (showBusy) {
		document.getElementById("popBusyBox").style.display = "block";
	} else {
		document.getElementById("popBusyBox").style.display = "none";
	}
	gPopupIsShown = true;
	disableTabIndexes();
	gPopupMask.style.display = "block";
	gPopupContainer.style.display = "block";
	// calculate where to place the window on screen
	centerPopWin(width, height);
	
	var titleBarHeight = parseInt(document.getElementById("popupTitleBar").offsetHeight, 10);


	gPopupContainer.style.width = width + "px";
	gPopupContainer.style.height = (height+titleBarHeight) + "px";
	
	setMaskSize();

	// need to set the width of the iframe to the title bar width because of the dropshadow
	// some oddness was occuring and causing the frame to poke outside the border in IE6
	gPopFrame.style.width = parseInt(document.getElementById("popupTitleBar").offsetWidth, 10) + "px";
	gPopFrame.style.height = (height) + "px";
	
	
	
	gReturnFunc = returnFunc;
	// for IE
	if (gHideSelects == true) {
		hideSelectBoxes();
	}
	
	// set the content 
	var closeBtn;
	var contentDocument;
	var contentDocumentBody;
	if (window.navigator.userAgent.indexOf("MSIE") > -1){
		contentDocument = document.frames["popupFrame"].document;
		contentDocumentBody = contentDocument.body;
	}else{
		contentDocument = document.getElementById("popupFrame").contentDocument;
		contentDocumentBody = contentDocument.getElementsByTagName("body")[0];
	}
	if(showBusy || !showCloseBox){
		contentDocumentBody.innerHTML = url;
	}else{
		closeBtn = '<input id="btn" type="button" onclick="window.top.hidePopWin(true)" value="Close" class="buttonBox" >';
		contentDocumentBody.innerHTML = url + closeBtn;
		contentDocument.getElementById("btn").focus();
	}
	
	//window.setTimeout("setPopTitle();", 600);
	document.getElementById("popupTitle").innerHTML = title;
}

 /**
	* @argument width - int in pixels
	* @argument height - int in pixels
	* @argument url - url to display
	* @argument returnFunc - function to call when returning true from the window.
	* @argument showCloseBox - show the close box - default true
	*/

function showConfirmWin(url, width, height, returnFunc,showCloseBox, title) {
	// show or hide the window close widget
	if (showCloseBox) {
		document.getElementById("popCloseBox").style.display = "block";
	} else {
		document.getElementById("popCloseBox").style.display = "none";
	}
	document.getElementById("popBusyBox").style.display = "none";
	gPopupIsShown = true;
	disableTabIndexes();
	gPopupMask.style.display = "block";
	gPopupContainer.style.display = "block";
	// calculate where to place the window on screen
	centerPopWin(width, height);
	
	var titleBarHeight = parseInt(document.getElementById("popupTitleBar").offsetHeight, 10);


	gPopupContainer.style.width = width + "px";
	gPopupContainer.style.height = (height+titleBarHeight) + "px";
	
	setMaskSize();

	// need to set the width of the iframe to the title bar width because of the dropshadow
	// some oddness was occuring and causing the frame to poke outside the border in IE6
	gPopFrame.style.width = parseInt(document.getElementById("popupTitleBar").offsetWidth, 10) + "px";
	gPopFrame.style.height = (height) + "px";
	
	// set the url
	//gPopFrame.src = url;
	//gPopFrame.document.body.innerHTML=url
	gReturnFunc = returnFunc;
	// for IE
	if (gHideSelects == true) {
		hideSelectBoxes();
	}
	var contentDocument;
	var contentDocumentBody;
	if (window.navigator.userAgent.indexOf("MSIE") > -1){
		contentDocument = document.frames["popupFrame"].document;
		contentDocumentBody = contentDocument.body;
	}else{
		contentDocument = document.getElementById("popupFrame").contentDocument;
		contentDocumentBody = contentDocument.getElementsByTagName("body")[0];
	}
	var closeBtn = '<p align="center"><input  type="button" onclick="window.top.hidePopWin(true)" value="Yes" style="width:70px;background-color:#f7f7f7;"><span style="width:40px">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span><input id="btn" type="button" onclick="window.top.hidePopWin()" value="No" style="width:70px;background-color:#f7f7f7;"></p>';
	
	contentDocumentBody.innerHTML = url + closeBtn;
	contentDocument.getElementById("btn").focus();
	
	//window.setTimeout("setPopTitle();", 600);
	document.getElementById("popupTitle").innerHTML = title;
	return contentDocument;
}

/**
	* @argument width - int in pixels
	* @argument height - int in pixels
	* @argument url - url to display
	* @argument returnFunc - function to call when returning true from the window.
	* @argument showCloseBox - show the close box - default true
	*/

function showFormWin(url, width, height, returnFunc,showCloseBox, title,btnTxt) {
	// show or hide the window close widget
	if (showCloseBox) {			
		document.getElementById("popCloseBox").style.display = "block";
	} else {
		document.getElementById("popCloseBox").style.display = "none";
	}
	document.getElementById("popBusyBox").style.display = "none";
	gPopupIsShown = true;
	disableTabIndexes();
	gPopupMask.style.display = "block";
	gPopupContainer.style.display = "block";
	// calculate where to place the window on screen
	centerPopWin(width, height);
	
	var titleBarHeight = parseInt(document.getElementById("popupTitleBar").offsetHeight, 10);


	gPopupContainer.style.width = width + "px";
	gPopupContainer.style.height = (height+titleBarHeight) + "px";
	
	setMaskSize();

	// need to set the width of the iframe to the title bar width because of the dropshadow
	// some oddness was occuring and causing the frame to poke outside the border in IE6
	gPopFrame.style.width = parseInt(document.getElementById("popupTitleBar").offsetWidth, 10) + "px";
	gPopFrame.style.height = (height) + "px";
	
	// set the url
	//gPopFrame.src = url;
	//gPopFrame.document.body.innerHTML=url
	gReturnFunc = returnFunc;
	// for IE
	if (gHideSelects == true) {
		hideSelectBoxes();
	}
	if(btnTxt==null) btnTxt="Send";
	var closeBtn = '<div ><input  type="button" onclick="window.top.callOwner(true)" value="'+btnTxt+'" class="buttonBox"><input id="btn" type="button" onclick="window.top.hidePopWin()" value="Cancel" class="buttonBox" style="right:10px"></div>';
	var contentDocument;
	var contentDocumentBody;
	var contentFrame;
	if (window.navigator.userAgent.indexOf("MSIE") > -1){
		contentFrame = document.frames["popupFrame"];
		contentDocument = contentFrame.document;
		contentDocumentBody = contentDocument.body;
	}else{
		contentFrame = document.getElementById("popupFrame");
		contentDocument = contentFrame.contentDocument;
		contentDocumentBody = contentDocument.getElementsByTagName("body")[0];
	}
	
	contentDocumentBody.innerHTML = url + closeBtn;
	contentDocument.getElementById("btn").focus();		
	
	//window.setTimeout("setPopTitle();", 600);
	document.getElementById("popupTitle").innerHTML = title;
	contentFrame.returnVal = contentDocument.forms["changPasswordFrm"];
	return contentDocument;

}


//
var gi = 0;
function centerPopWin(width, height) {
	if (gPopupIsShown == true) {
		if (width == null || isNaN(width)) {
			width = gPopupContainer.offsetWidth;
		}
		if (height == null) {
			height = gPopupContainer.offsetHeight;
		}
		
		//var theBody = document.documentElement;
		var theBody = document.getElementsByTagName("BODY")[0];
		//theBody.style.overflow = "hidden";
		var scTop = parseInt(getScrollTop(),10);
		var scLeft = parseInt(theBody.scrollLeft,10);
	
		setMaskSize();
		
		//window.status = gPopupMask.style.top + " " + gPopupMask.style.left + " " + gi++;
		
		var titleBarHeight = parseInt(document.getElementById("popupTitleBar").offsetHeight, 10);
		
		var fullHeight = getViewportHeight();
		var fullWidth = getViewportWidth();
		
		gPopupContainer.style.top = (scTop + ((fullHeight - (height+titleBarHeight)) / 2)) + "px";
		gPopupContainer.style.left =  (scLeft + ((fullWidth - width) / 2)) + "px";
		//alert(fullWidth + " " + width + " " + gPopupContainer.style.left);
	}
}
addEvent(window, "resize", centerPopWin);
addEvent(window, "scroll", centerPopWin);
window.onscroll = centerPopWin;


/**
 * Sets the size of the popup mask.
 *
 */
function setMaskSize() {
	var theBody = document.getElementsByTagName("BODY")[0];
			
	var fullHeight = getViewportHeight();
	var fullWidth = getViewportWidth();
	
	// Determine what's bigger, scrollHeight or fullHeight / width
	if (fullHeight > theBody.scrollHeight) {
		popHeight = fullHeight;
	} else {
		popHeight = theBody.scrollHeight;
	}
	
	if (fullWidth > theBody.scrollWidth) {
		popWidth = fullWidth;
	} else {
		popWidth = theBody.scrollWidth;
	}
	
	gPopupMask.style.height = popHeight + "px";
	gPopupMask.style.width = popWidth + "px";
}

/**
 * @argument callReturnFunc - bool - determines if we call the return function specified
 * @argument returnVal - anything - return value 
 */
function hidePopWin(callReturnFunc) {
	removeCalendar();
	if(diagnosticDataInterval!=null)
		window.clearInterval(diagnosticDataInterval);
	gPopupIsShown = false;
	var theBody = document.getElementsByTagName("BODY")[0];
	theBody.style.overflow = "";
	restoreTabIndexes();
	if (gPopupMask == null) {
		return;
	}
	gPopupMask.style.display = "none";
	gPopupContainer.style.display = "none";
	if (callReturnFunc == true && gReturnFunc != null) {
		// Set the return code to run in a timeout.
		// Was having issues using with an Ajax.Request();
		gReturnVal = window.frames["popupFrame"].returnVal;		
		window.setTimeout('gReturnFunc(gReturnVal);', 100);
	}
	gPopFrame.src = gDefaultPage;
	// display all select boxes
	if (gHideSelects == true) {
		displaySelectBoxes();
	}
}

/**
 * @argument callReturnFunc - bool - determines if we call the return function specified
 * @argument returnVal - anything - return value 
 */
function callOwner(callReturnFunc) {
	
	if (callReturnFunc == true && gReturnFunc != null) {
		// Set the return code to run in a timeout.
		// Was having issues using with an Ajax.Request();
		if (window.navigator.userAgent.indexOf("MSIE") > -1) 
		gReturnVal = window.frames["popupFrame"].returnVal;
			else		
		gReturnVal = document.getElementById("popupFrame").returnVal;
		
		window.setTimeout('gReturnFunc(gReturnVal);', 1);
	}
	
}

function popFormSetMessage(str){
	if (window.navigator.userAgent.indexOf("MSIE") > -1) 
		document.frames["popupFrame"].document.getElementById("lblError").innerText = str;
	else
		document.getElementById("popupFrame").contentDocument.getElementById("lblError").innerHTML = str;
		
}



// Tab key trap. iff popup is shown and key was [TAB], suppress it.
// @argument e - event - keyboard event that caused this function to be called.
function keyDownHandler(e) {
    if (gPopupIsShown && e.keyCode == 9)  return false;
}

// For IE.  Go through predefined tags and disable tabbing into them.
function disableTabIndexes() {
	
	if (document.all) {
		var i = 0;
		for (var j = 0; j < gTabbableTags.length; j++) {
			var tagElements = document.getElementsByTagName(gTabbableTags[j]);
			for (var k = 0 ; k < tagElements.length; k++) {
				gTabIndexes[i] = tagElements[k].tabIndex;
				tagElements[k].tabIndex="-1";
				if(tagElements[k].type != null && tagElements[k].type=="submit" && tagElements[k].id!=""){
					document.getElementById(tagElements[k].id).disabled=true;
					//alert(tagElements[k].id)
					//tagElements[k].disable=true;
				}
				i++;
				//if radio group -> mark the correct value 
				if(tagElements[k].length != null && tagElements[k][0].type=="radio"){
					for(var x=0;x<tagElements[k].length;x++){
						gTabIndexes[i] = tagElements[k][x].tabIndex;
						tagElements[k][x].tabIndex="-1";
						i++;
					}
				}
			}
		}
	}
}

// For IE. Restore tab-indexes.
function restoreTabIndexes() {
	if (document.all) {
		var i = 0;
		for (var j = 0; j < gTabbableTags.length; j++) {
			var tagElements = document.getElementsByTagName(gTabbableTags[j]);
			for (var k = 0 ; k < tagElements.length; k++) {
				tagElements[k].tabIndex = gTabIndexes[i];
				tagElements[k].tabEnabled = true;
				if(tagElements[k].type != null && tagElements[k].type=="submit" && tagElements[k].id!="")
					document.getElementById(tagElements[k].id).disabled=false;
				i++;
				//if radio group -> mark the correct value 
				if(tagElements[k].length != null && tagElements[k][0].type=="radio"){
					for(var x=0;x<tagElements[k].length;x++){
						tagElements[k][x].tabIndex = gTabIndexes[i];
						tagElements[k][x].tabEnabled = true;
						i++;
					}
				}
			}
		}
	}
}


/**
* Hides all drop down form select boxes on the screen so they do not appear above the mask layer.
* IE has a problem with wanted select form tags to always be the topmost z-index or layer
*
* Thanks for the code Scott!
*/
function hideSelectBoxes() {
	for(var i = 0; i < document.forms.length; i++) {
		for(var e = 0; e < document.forms[i].length; e++){
			if(document.forms[i].elements[e].tagName == "SELECT") {
				document.forms[i].elements[e].style.visibility="hidden";
			}
		}
	}
}

/**
* Makes all drop down form select boxes on the screen visible so they do not reappear after the dialog is closed.
* IE has a problem with wanted select form tags to always be the topmost z-index or layer
*/
function displaySelectBoxes() {
	for(var i = 0; i < document.forms.length; i++) {
		for(var e = 0; e < document.forms[i].length; e++){
			if(document.forms[i].elements[e].tagName == "SELECT") {
			document.forms[i].elements[e].style.visibility="visible";
			}
		}
	}
}

